Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs	(revision 9089)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("CountNumberOfUniqueActions", "")]
+  [StorableClass]
+  public class CountNumberOfUniqueActions : SingleSuccessorOperator {
+
+    public ILookupParameter<ItemArray<IClassifier>> ClassifiersParameter {
+      get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["Classifiers"]; }
+    }
+    public IValueLookupParameter<IItemSet<IClassifier>> UniqueActionsParameter {
+      get { return (IValueLookupParameter<IItemSet<IClassifier>>)Parameters["UniqueActions"]; }
+    }
+
+    [StorableConstructor]
+    protected CountNumberOfUniqueActions(bool deserializing) : base(deserializing) { }
+    protected CountNumberOfUniqueActions(CountNumberOfUniqueActions original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CountNumberOfUniqueActions(this, cloner);
+    }
+    public CountNumberOfUniqueActions()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("Classifiers"));
+      Parameters.Add(new ValueLookupParameter<IItemSet<IClassifier>>("UniqueActions"));
+    }
+    public override IOperation Apply() {
+      ItemSet<IClassifier> actions = new ItemSet<IClassifier>();
+      foreach (var classifier in ClassifiersParameter.ActualValue) {
+        actions.Add(classifier.Action);
+      }
+      UniqueActionsParameter.Value = actions;
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs	(revision 9089)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("MatchActionOperator", "")]
+  [StorableClass]
+  public class MatchActionOperator : SingleSuccessorOperator {
+    protected ILookupParameter<BoolValue> MatchActionParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["MatchAction"]; }
+    }
+    public ILookupParameter<IClassifier> TargetMatchParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["TargetMatchParameter"]; }
+    }
+    public ILookupParameter<IClassifier> MatchParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["MatchParameter"]; }
+    }
+
+    [StorableConstructor]
+    protected MatchActionOperator(bool deserializing) : base(deserializing) { }
+    protected MatchActionOperator(MatchActionOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MatchActionOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<BoolValue>("MatchAction", "True if the action matches."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MatchActionOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IClassifier target = TargetMatchParameter.ActualValue;
+      IClassifier match = MatchParameter.ActualValue;
+      MatchActionParameter.ActualValue = new BoolValue(match.MatchAction(target));
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs	(revision 9089)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("MatchConditionOperator", "")]
+  [StorableClass]
+  public class MatchConditionOperator : SingleSuccessorOperator {
+    protected ILookupParameter<BoolValue> MatchConditionParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["MatchCondition"]; }
+    }
+    public ILookupParameter<IClassifier> TargetMatchParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["TargetMatchParameter"]; }
+    }
+    public ILookupParameter<IClassifier> MatchParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["MatchParameter"]; }
+    }
+
+    [StorableConstructor]
+    protected MatchConditionOperator(bool deserializing) : base(deserializing) { }
+    protected MatchConditionOperator(MatchConditionOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MatchConditionOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<BoolValue>("MatchCondition", "True if the condition matches."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MatchConditionOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IClassifier target = TargetMatchParameter.ActualValue;
+      IClassifier match = MatchParameter.ActualValue;
+      MatchConditionParameter.ActualValue = new BoolValue(match.MatchCondition(target));
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs	(revision 9089)
@@ -0,0 +1,92 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("PredictionArrayCalculator", "")]
+  [StorableClass]
+  public class PredictionArrayCalculator : SingleSuccessorOperator {
+
+    public ILookupParameter<ItemArray<DoubleValue>> FitnessParameter {
+      get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Fitness"]; }
+    }
+    public ILookupParameter<ItemArray<DoubleValue>> PredictionParameter {
+      get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Prediction"]; }
+    }
+    public IValueParameter<IItemDictionary<IClassifier, DoubleValue>> PredictionArrayParameter {
+      get { return (IValueParameter<IItemDictionary<IClassifier, DoubleValue>>)Parameters["PredictionArray"]; }
+    }
+    public ILookupParameter<ItemArray<IClassifier>> MatchParameter {
+      get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["MatchParameter"]; }
+    }
+
+    [StorableConstructor]
+    protected PredictionArrayCalculator(bool deserializing) : base(deserializing) { }
+    protected PredictionArrayCalculator(PredictionArrayCalculator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public PredictionArrayCalculator()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Fitness"));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Prediction"));
+      Parameters.Add(new ValueLookupParameter<IItemDictionary<IClassifier, DoubleValue>>("PredictionArray"));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PredictionArrayCalculator(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      IItemDictionary<IClassifier, DoubleValue> predictionArray = new ItemDictionary<IClassifier, DoubleValue>();
+      IDictionary<IClassifier, double> fitnessSumPerAction = new Dictionary<IClassifier, double>();
+      ItemArray<DoubleValue> fitnesses = FitnessParameter.ActualValue;
+      ItemArray<DoubleValue> predictions = PredictionParameter.ActualValue;
+      for (int i = 0; i < MatchParameter.ActualValue.Length; i++) {
+        var action = MatchParameter.ActualValue[i].Action;
+        if (predictionArray.ContainsKey(action)) {
+          predictionArray[action].Value += predictions[i].Value * fitnesses[i].Value;
+          fitnessSumPerAction[action] += fitnesses[i].Value;
+        } else {
+          predictionArray[action] = new DoubleValue(predictions[i].Value * fitnesses[i].Value);
+          fitnessSumPerAction[action] = fitnesses[i].Value;
+        }
+      }
+
+      foreach (var action in predictionArray.Keys) {
+        if (fitnessSumPerAction[action] != 0) {
+          predictionArray[action].Value /= fitnessSumPerAction[action];
+        }
+      }
+
+      PredictionArrayParameter.ActualValue = predictionArray;
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/SumAccuracy.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/SumAccuracy.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/SumAccuracy.cs	(revision 9089)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("SumAccuracy", "")]
+  [StorableClass]
+  public class SumAccuracy : SingleSuccessorOperator {
+    public ILookupParameter<ItemArray<DoubleValue>> AccuracyParameter {
+      get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Accuracy"]; }
+    }
+    public ILookupParameter<ItemArray<IntValue>> NumerosityParameter {
+      get { return (ILookupParameter<ItemArray<IntValue>>)Parameters["Numerosity"]; }
+    }
+    protected IValueLookupParameter<DoubleValue> AccuracySumParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["AccuracySum"]; }
+    }
+
+    [StorableConstructor]
+    protected SumAccuracy(bool deserializing) : base(deserializing) { }
+    protected SumAccuracy(SumAccuracy original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public SumAccuracy()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Accuracy"));
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Numerosity"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("AccuracySum"));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SumAccuracy(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      ItemArray<DoubleValue> accuracies = AccuracyParameter.ActualValue;
+      ItemArray<IntValue> numerosities = NumerosityParameter.ActualValue;
+      double accuracySum = 0.0;
+      for (int i = 0; i < accuracies.Length; i++) {
+        accuracySum += accuracies[i].Value * numerosities[i].Value;
+      }
+      AccuracySumParameter.ActualValue = new DoubleValue(accuracySum);
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame	(revision 9089)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Plugin("HeuristicLab.Encodings.ConditionActionEncoding", "3.3.7.$WCREV$")]
+  [PluginFile("HeuristicLab.Encodings.ConditionActionEncoding-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  public class HeuristicLabEncodingsConditionActionEncodingPlugin : PluginBase {
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Properties/AssemblyInfo.cs.frame	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Properties/AssemblyInfo.cs.frame	(revision 9089)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Encodings.ConditionActionEncoding-3.3")]
+[assembly: AssemblyDescription("A general implementation of encodings with condition and action part.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("66e09f77-028d-4bea-94ff-e6a224aa4aac")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.7.$WCREV$")]
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs	(revision 9089)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("ActionExecuter", "")]
+  [StorableClass]
+  public class ActionExecuter : SingleSuccessorOperator, IActionExecuter {
+
+    #region parameter
+    public IValueLookupParameter<IClassifier> SelectedActionParameter {
+      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    }
+    public IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter {
+      get { return (IValueLookupParameter<IClassifier>)Parameters["CurrentClassifierToMatch"]; }
+    }
+    public IValueLookupParameter<DoubleValue> CurrentPayoffParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["CurrentPayoff"]; }
+    }
+    public ILookupParameter<DoubleValue> NegativeRewardParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["NegativeReward"]; }
+    }
+    public ILookupParameter<DoubleValue> PositiveRewardParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["PositiveReward"]; }
+    }
+    #endregion
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ActionExecuter(this, cloner);
+    }
+    protected ActionExecuter(ActionExecuter original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    [StorableConstructor]
+    protected ActionExecuter(bool deserializing) : base(deserializing) { }
+
+    public ActionExecuter()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction"));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("CurrentClassifierToMatch"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("CurrentPayoff"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("NegativeReward"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("PositiveReward"));
+    }
+
+    public override IOperation Apply() {
+      if (SelectedActionParameter.ActualValue.Action.Equals(CurrentClassifierToMatchParameter.ActualValue.Action)) {
+        CurrentPayoffParameter.ActualValue = PositiveRewardParameter.ActualValue;
+      } else {
+        CurrentPayoffParameter.ActualValue = NegativeRewardParameter.ActualValue;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs	(revision 9089)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IActionExecuter : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
+    IValueLookupParameter<IClassifier> SelectedActionParameter { get; }
+    IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter { get; }
+    IValueLookupParameter<DoubleValue> CurrentPayoffParameter { get; }
+    ILookupParameter<DoubleValue> NegativeRewardParameter { get; }
+    ILookupParameter<DoubleValue> PositiveRewardParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs	(revision 9089)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IClassifierFetcher : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
+    IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter { get; }
+    ILookupParameter<IConditionActionProblemData> ProblemDataParameter { get; }
+    ILookupParameter<IntValue> IterationParameter { get; }
+  }
+}
